template <typename T>
struct VALUESID
{
  static int Reserve;

  T Values[];

  bool operator +=( const T &Value )
  {
    const int Size = ::ArraySize(this.Values);
    const bool Res = !Size || (this.Values[Size - 1] != Value);

    if (Res)
      this.Values[::ArrayResize(this.Values, Size + 1, VALUESID<T>::Reserve) - 1] = Value;

    return(Res);
  }

  int Copy( T &Array[] ) const
  {
    return(::ArrayCopy(Array, this.Values));
  }
};

template <typename T>
static int VALUESID::Reserve = 0;
